/* Example 4: Generic Interfaces
 * Demonstrates how to compare apples with apples and pears with pears,
 * but the type-check ensures that it is not allowed to compare apples with pears
 *  */


interface EQ<T> {
	boolean equalsTo(T t);
}

class Apple implements EQ<Apple>{
	int weight;
	Apple(int weight) {
		this.weight=weight;
	}
	public boolean equalsTo(Apple a) {
		return this.weight == a.weight;
	}
}

class Pear implements EQ<Pear>{
	int weight;
	Pear(int weight) {
		this.weight=weight;
	}
	public boolean equalsTo(Pear a) {
		return this.weight == a.weight;
	}
}

public class Example4 {
	public static void main(String[] args) {
		Apple apple1 = new Apple(50);
		Apple apple2 = new Apple(55);
		Pear  pear1  = new Pear(45);
		apple1.equalsTo(apple2);
		apple1.equalsTo(pear1); // compile time error
	}
}
